Package ghidra.trace.database.program

# Class DBTraceProgramViewPropertyMapManager

java.lang.Object
ghidra.trace.database.program.DBTraceProgramViewPropertyMapManager

All Implemented Interfaces:
  `PropertyMapManager`

public class DBTraceProgramViewPropertyMapManager extends Object implements PropertyMapManager

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected class`
  `DBTraceProgramViewPropertyMapManager.AbstractDBTraceProgramViewPropertyMap<T>`
  `protected class`
  `DBTraceProgramViewPropertyMapManager.DBTraceProgramViewIntPropertyMap`
  `protected class`
  `DBTraceProgramViewPropertyMapManager.DBTraceProgramViewLongPropertyMap`
  `protected class`
  `DBTraceProgramViewPropertyMapManager.DBTraceProgramViewObjectPropertyMap<T extends Saveable>`
  `protected class`
  `DBTraceProgramViewPropertyMapManager.DBTraceProgramViewStringPropertyMap`
  `protected class`
  `DBTraceProgramViewPropertyMapManager.DBTraceProgramViewVoidPropertyMap`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final DBTraceProgramView`
  `program`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DBTraceProgramViewPropertyMapManager(DBTraceProgramView program)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `IntPropertyMap`
  `createIntPropertyMap(String propertyName)`
  Creates a new IntPropertyMap with the given name.
  `LongPropertyMap`
  `createLongPropertyMap(String propertyName)`
  Creates a new LongPropertyMap with the given name.
  `<T extends Saveable>
  ObjectPropertyMap<T>`
  `createObjectPropertyMap(String propertyName, Class<T> objectClass)`
  Creates a new ObjectPropertyMap with the given name.
  `StringPropertyMap`
  `createStringPropertyMap(String propertyName)`
  Creates a new StringPropertyMap with the given name.
  `VoidPropertyMap`
  `createVoidPropertyMap(String propertyName)`
  Creates a new VoidPropertyMap with the given name.
  `IntPropertyMap`
  `getIntPropertyMap(String propertyName)`
  Returns the IntPropertyMap associated with the given name.
  `LongPropertyMap`
  `getLongPropertyMap(String propertyName)`
  Returns the LongPropertyMap associated with the given name.
  `ObjectPropertyMap<? extends Saveable>`
  `getObjectPropertyMap(String propertyName)`
  Returns the ObjectPropertyMap associated with the given name.
  `PropertyMap<?>`
  `getPropertyMap(String propertyName)`
  Returns the PropertyMap with the given name or null if no PropertyMap exists with that name.
  `StringPropertyMap`
  `getStringPropertyMap(String propertyName)`
  Returns the StringPropertyMap associated with the given name.
  `VoidPropertyMap`
  `getVoidPropertyMap(String propertyName)`
  Returns the VoidPropertyMap associated with the given name.
  `Iterator<String>`
  `propertyManagers()`
  Returns an iterator over the names of all existing PropertyMaps sorted by name.
  `void`
  `removeAll(Address addr)`
  Removes any property at the given address from all defined PropertyMaps.
  `void`
  `removeAll(Address startAddr, Address endAddr, TaskMonitor monitor)`
  Removes all properties in the given range from all user defined PropertyMaps.
  `protected void`
  `removeAll(Lifespan span, AddressRange range)`
  `boolean`
  `removePropertyMap(String propertyName)`
  Removes the PropertyMap with the given name.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### program

    protected final DBTraceProgramView program

- ## Constructor Details

  - ### DBTraceProgramViewPropertyMapManager

    public DBTraceProgramViewPropertyMapManager(DBTraceProgramView program)

- ## Method Details

  - ### createIntPropertyMap

    public IntPropertyMap createIntPropertyMap(String propertyName) throws DuplicateNameException
    Description copied from interface: `PropertyMapManager`
    Creates a new IntPropertyMap with the given name.
    Specified by:
      `createIntPropertyMap` in interface `PropertyMapManager`
    Parameters:
      `propertyName` - the name for the new property.
    Returns:
      newly created integer object map
    Throws:
      `DuplicateNameException` - thrown if a PropertyMap already exists with that name.

  - ### createLongPropertyMap

    public LongPropertyMap createLongPropertyMap(String propertyName) throws DuplicateNameException
    Description copied from interface: `PropertyMapManager`
    Creates a new LongPropertyMap with the given name.
    Specified by:
      `createLongPropertyMap` in interface `PropertyMapManager`
    Parameters:
      `propertyName` - the name for the new property.
    Returns:
      newly created long object map
    Throws:
      `DuplicateNameException` - thrown if a PropertyMap already exists with that name.

  - ### createStringPropertyMap

    public StringPropertyMap createStringPropertyMap(String propertyName) throws DuplicateNameException
    Description copied from interface: `PropertyMapManager`
    Creates a new StringPropertyMap with the given name.
    Specified by:
      `createStringPropertyMap` in interface `PropertyMapManager`
    Parameters:
      `propertyName` - the name for the new property.
    Returns:
      newly created string object map
    Throws:
      `DuplicateNameException` - thrown if a PropertyMap already exists with that name.

  - ### createObjectPropertyMap

    public <T extends Saveable> ObjectPropertyMap<T> createObjectPropertyMap(String propertyName, Class<T> objectClass) throws DuplicateNameException
    Description copied from interface: `PropertyMapManager`
    Creates a new ObjectPropertyMap with the given name.
    Specified by:
      `createObjectPropertyMap` in interface `PropertyMapManager`
    Type Parameters:
      `T` - `Saveable` property value type
    Parameters:
      `propertyName` - the name for the new property.
      `objectClass` - `Saveable` implementation class
    Returns:
      newly created `Saveable` object map
    Throws:
      `DuplicateNameException` - thrown if a PropertyMap already exists with that name.

  - ### createVoidPropertyMap

    public VoidPropertyMap createVoidPropertyMap(String propertyName) throws DuplicateNameException
    Description copied from interface: `PropertyMapManager`
    Creates a new VoidPropertyMap with the given name.
    Specified by:
      `createVoidPropertyMap` in interface `PropertyMapManager`
    Parameters:
      `propertyName` - the name for the new property.
    Returns:
      newly created void map
    Throws:
      `DuplicateNameException` - thrown if a PropertyMap already exists with that name.

  - ### getPropertyMap

    public PropertyMap<?> getPropertyMap(String propertyName)
    Description copied from interface: `PropertyMapManager`
    Returns the PropertyMap with the given name or null if no PropertyMap exists with that name.
    Specified by:
      `getPropertyMap` in interface `PropertyMapManager`
    Parameters:
      `propertyName` - the name of the property to retrieve.
    Returns:
      existing map or null if not found

  - ### getIntPropertyMap

    public IntPropertyMap getIntPropertyMap(String propertyName)
    Description copied from interface: `PropertyMapManager`
    Returns the IntPropertyMap associated with the given name.
    Specified by:
      `getIntPropertyMap` in interface `PropertyMapManager`
    Parameters:
      `propertyName` - the name of the property to retrieve.
    Returns:
      existing map or null if not found

  - ### getLongPropertyMap

    public LongPropertyMap getLongPropertyMap(String propertyName)
    Description copied from interface: `PropertyMapManager`
    Returns the LongPropertyMap associated with the given name.
    Specified by:
      `getLongPropertyMap` in interface `PropertyMapManager`
    Parameters:
      `propertyName` - the name of the property to retrieve.
    Returns:
      existing map or null if not found

  - ### getStringPropertyMap

    public StringPropertyMap getStringPropertyMap(String propertyName)
    Description copied from interface: `PropertyMapManager`
    Returns the StringPropertyMap associated with the given name.
    Specified by:
      `getStringPropertyMap` in interface `PropertyMapManager`
    Parameters:
      `propertyName` - the name of the property to retrieve.
    Returns:
      existing map or null if not found

  - ### getObjectPropertyMap

    public ObjectPropertyMap<? extends Saveable> getObjectPropertyMap(String propertyName)
    Description copied from interface: `PropertyMapManager`
    Returns the ObjectPropertyMap associated with the given name.
    Specified by:
      `getObjectPropertyMap` in interface `PropertyMapManager`
    Parameters:
      `propertyName` - the name of the property to retrieve.
    Returns:
      existing map or null if not found

  - ### getVoidPropertyMap

    public VoidPropertyMap getVoidPropertyMap(String propertyName)
    Description copied from interface: `PropertyMapManager`
    Returns the VoidPropertyMap associated with the given name.
    Specified by:
      `getVoidPropertyMap` in interface `PropertyMapManager`
    Parameters:
      `propertyName` - the name of the property to retrieve.
    Returns:
      existing map or null if not found

  - ### removePropertyMap

    public boolean removePropertyMap(String propertyName)
    Description copied from interface: `PropertyMapManager`
    Removes the PropertyMap with the given name.
    Specified by:
      `removePropertyMap` in interface `PropertyMapManager`
    Parameters:
      `propertyName` - the name of the property to remove.
    Returns:
      true if a PropertyMap with that name was found (and removed)

  - ### propertyManagers

    public Iterator<String> propertyManagers()
    Description copied from interface: `PropertyMapManager`
    Returns an iterator over the names of all existing PropertyMaps sorted by name.
    Specified by:
      `propertyManagers` in interface `PropertyMapManager`

  - ### removeAll

    protected void removeAll(Lifespan span, AddressRange range)

  - ### removeAll

    public void removeAll(Address addr)
    Description copied from interface: `PropertyMapManager`
    Removes any property at the given address from all defined PropertyMaps.
    Specified by:
      `removeAll` in interface `PropertyMapManager`
    Parameters:
      `addr` - the address at which to remove all property values.

  - ### removeAll

    public void removeAll(Address startAddr, Address endAddr, TaskMonitor monitor) throws CancelledException
    Description copied from interface: `PropertyMapManager`
    Removes all properties in the given range from all user defined PropertyMaps. The specified start and end addresses must form a valid range within a single `AddressSpace`.
    Specified by:
      `removeAll` in interface `PropertyMapManager`
    Parameters:
      `startAddr` - the first address in the range of addresses where propertie values are to be removed.
      `endAddr` - the last address in the range of addresses where propertie values are to be removed.
      `monitor` - monitors progress
    Throws:
      `CancelledException` - if the user cancelled the operation.